{$F+,O+}
{$Q-} {Overflow check OFF; see "ganaarxy" at line 96}
UNIT ksputs;

INTERFACE USES dos, crt, kstypvar, graph, grgencga;

function  LinesOnScreen: integer;
function  waarx: integer;
function  waary: integer;
procedure ganaarxy (x, y: integer);
procedure schrijfteken (c: char);
procedure schrijfstring (s: string);
procedure schrijfln;
procedure schoonscr;
procedure schooneol;
procedure clrupto (xe: integer);
procedure schoonupto (xe: integer);
procedure zetcolor (color: integer);
procedure tekstcolor (color: integer);
procedure tekstbackground (color: integer);
procedure setcursorsize (top, bottom: integer);
(*
procedure hidecursor;
procedure normalcursor;
procedure hidegcursor;
procedure normalgcursor;
procedure boldgcursor;
*)
procedure wegcursor;
procedure terugcursor;
procedure setvideo (attrib: integer);
procedure guidance (line: integer; state: stringMaxL; text: string);
procedure cleareol (line, col, attrib: integer);
procedure putstring (outstring: stringMaxL; line, col, attrib: integer);
procedure geefblankostaart (var s: stringMaxL; l: integer);
procedure putpromptedstring (outstring: stringMaxL; attrib, strlength: integer;
                             descstr: stringMaxL; descline, desccol: integer;
                             newline: boolean);
procedure showstring (instring: stringMaxL; line, col, attrib, strlength: integer);
procedure putcenteredstring (outstring: stringMaxL; line, attrib: integer);
procedure putprompt (outstring: stringMaxL; line, col: integer);
procedure puterror (outstring: stringMaxL; line, col: integer);
procedure writeinteger (r: integer; f: integer; fgcolor, bgcolor: integer);
procedure writereal (r: real; f, g: integer; fgcolor, bgcolor: integer);
procedure writestring (s: string; fgcolor, bgcolor: integer);

IMPLEMENTATION

function  LinesOnScreen: integer;
{-------------------------------}
begin
 case PGgr of
 False: LinesOnScreen := 25; {Full screen}
 True:  LinesOnScreen := 47; {Full screen at resolution 640X480}
 end; {case PGgr}
end; {LinesOnScreen}

function waarx: integer;
{----------------------}
begin
 case PGgr of
 False: waarx := wherex;
 True:  waarx := PGx;
 end; {case PGgr}
end; {waarx}

function waary: integer;
{----------------------}
begin
 case PGgr of
 False: waary := wherey;
 True:  waary := PGy;
 end; {case PGgr}
end; {waary}

procedure wipegcursor;
{--------------------}
{PRE: Graphics mode ON}
var color, i: integer;
begin
 {Save current color:} color := getcolor;
 {Wipe graphic cursor:}
 setcolor (black);
 for i := 1 to gcursor do
 begin moveto (PGpx, PGpy + 8 + i); linerel (6, 0); end; {for i}
 {Restore current color:} setcolor (color);
end; {wipegcursor}

procedure showgcursor;
{--------------------}
{PRE: Graphics mode ON}
var color, i: integer;
begin
 {Save current color:} color := getcolor;
 {Show graphic cursor:}
 setcolor (white);
 for i := 1 to gcursor do
 begin moveto (PGpx, PGpy + 8 + i); linerel (6, 0); end; {for i}
 {Restore current color:} setcolor (color);
end; {showgcursor}

procedure ganaarxy (x, y: integer);
{---------------------------------}
{Aug 18th 2001: in unit ABZB executing in graphics mode you sometimes get
spurious assignments, resulting in PGx and/or PGy being different
from x and y, respectively. The values of PGx and PGy look arbitrary, and may
cause arithmetic overflow. Overflow cheching for KSPUTS turned OFF.}
begin
 case PGgr of
 False: gotoxy (x, y);
 True:  begin
         wipegcursor;
         PGx := x;
         PGy := y;
         PGpx := PGCharWidth * (PGx - 1);
         PGpy := PGCharHeight * (PGy - 1);
         showgcursor;
        end; {PGgr = True}
 end; {case PGgr}
end; {ganaarxy}

procedure schrijfteken (c: char);
{-------------------------------}
var color: integer;
begin
 case PGgr of
 False: write (c);
 True:  begin
         wipegcursor;
         settextjustify (lefttext, toptext);
         color := getcolor;
         setcolor (Gbgcolor); outtextxy (PGpx, PGpy, #219);
         setcolor (color); outtextxy (PGpx, PGpy, c);
         PGx := PGx + 1;
         if PGx > PGLineWidth then begin PGx := 1; PGy := PGy + 1; end;
         PGpx := PGCharWidth * (PGx - 1); PGpy := PGCharHeight * (PGy - 1);
         showgcursor;
        end; {PGgr = True}
 end; {case PGgr}
end; {schrijfteken}

procedure schrijfstring (s: string);
{----------------------------------}
var i: integer;
begin
 case PGgr of
 False: write (s);
 True:  for i := 1 to length (s) do schrijfteken (s[i]);
 end; {case PGgr}
end; {schrijfstring}

procedure schrijfln;
{------------------}
begin
 case PGgr of
 False: writeln;
 True:  ganaarxy (1, waary + 1);
 end; {case PGgr}
end; {schrijfln}

procedure schoonscr;
{------------------}
begin
 case PGgr of
 False: clrscr;
 True : begin cleardevice; ganaarxy (1, 1); end; {PGgr = True}
 end; {case PGgr}
end; {schoonscr}

procedure schooneol;
{------------------}
var i, color: integer;
begin
 case PGgr of
 False: clreol;
 True : begin
            color := getcolor; setcolor (Gbgcolor);
            settextjustify (lefttext, toptext);
            for i := PGx to 80 do outtextxy (PGCharWidth * (i - 1), PGCharHeight * (PGy - 1), #219);
            setcolor (color);
           end; {PGgr = True}
 end; {case PGgr}
end; {schooneol}

procedure clrupto (xe: integer);
{------------------------------}
{PURPOSE: Clears current line from cursor position up to and including
position xe; returns cursor to original position. Text mode version}
var i, xb: integer;
begin
 xb := wherex; for i := xb to xe do write (' '); gotoxy (xb, wherey);
end; {clrupto}

procedure schoonupto (xe: integer);
{---------------------------------}
{PURPOSE: Clears current line from cursor position up to and including
position xe; returns cursor to original position. Dual version}
var i, xb: integer;
begin
 xb := waarx; for i := xb to xe do schrijfteken (' '); ganaarxy (xb, waary);
end; {schoonupto}

procedure zetcolor (color: integer);
{----------------------------------}
begin
 if PGgr then setcolor (color) else textcolor (color);
end; {zetcolor}

procedure tekstcolor (color: integer);
{------------------------------------}
begin
 case PGgr of
 False: textcolor (color);
 True : setcolor (color);
 end; {case PGgr}
end; {tekstcolor}

procedure tekstbackground (color: integer);
{-----------------------------------------}
begin
 case PGgr of
 False: textbackground (color);
 True : Gbgcolor := color;
 end; {case PGgr}
end; {tekstbackground}

procedure setcursorsize (top, bottom: integer);
{---------------------------------------------}
{Cursor scan lines:

       Color graphics:   0 <= top <= bottom  7
       Monochrome:       0 <= top <= bottom  13
       Invisible cursor: top > bottom; schijnt niet te werken
                         voor kleurendisplays.}

{type registers = record ax, bx, cx, dx, bp, si, di, ds, es, flags: integer; end;}
{Zie Turbo-PASCAL-4-boek p. 437; Jump: Programmer's Guide to MS-DOS p. 208}
var regs: registers;
begin with regs do
 begin
  ax := $0100; cx := (top shl 8) + bottom; intr ($10, regs);
 end; {with regs}
end; {setcursorsize}

procedure hidecursor; begin setcursorsize (7, 7); end; {1 line, for lack of really hiding}

procedure normalcursor; begin setcursorsize (5, 7); end; {3 lines}

procedure hidegcursor;
begin
 if PGgr then wipegcursor; gcursor := 0;
end; {hidegcursor}

procedure normalgcursor;
begin
 if PGgr then wipegcursor; gcursor := 1; if PGgr then showgcursor;
end; {normalgcursor}

procedure boldgcursor;
begin
 if PGgr then wipegcursor; gcursor := 2; if PGgr then showgcursor;
end; {boldgcursor}

procedure wegcursor;
begin hidecursor; hidegcursor; end; {wegcursor}

procedure terugcursor;
begin normalcursor; boldgcursor; end; {terugcursor}

procedure setvideo (attrib: integer);
{-----------------------------------}
{PURPOSE: Sets video attribute for future input and output}
{NOTES: The video attribute is bit-based. 1-bit: reverse; 2-bit: bold;
4-bit: blinking; 8-bit: colored; 0 = normal}
var coloredv, blinkingv, boldv, reversev: integer;
var auxcolor: integer;
begin
 coloredv := (attrib and 8) div 8;      {0 ro 1}
 blinkingv := (attrib and 4) * 4;       {0 or 16}
 boldv := (attrib and 2) div 2;         {0 or 1}
 reversev := (attrib and 1);            {0 or 1}
 if coloredv = 0 then auxcolor := white else auxcolor := lightcyan;
 if   reversev = 0
 then begin {<stkleur> or white text on black background:}
       tekstcolor (STColor + (auxcolor-STColor)*boldv + blinkingv);
       tekstbackground (black);
      end {reversev = 0}
 else begin {<vgkleur> or white text on <agkleur> background:}
       tekstcolor (FGColor + (auxcolor-FGColor)*boldv + blinkingv);
       tekstbackground (BGColor);
      end; {reversev <> 0}
end; {setvideo}

procedure guidance (line: integer; state: stringMaxL; text: string);
{------------------------------------------------------------------}
{Provide guidance:}
begin
 ganaarxy (1, line);
 tekstbackground (blue); tekstcolor (lightgreen);
 schrijfstring (' ' + state + ' ');
 tekstcolor (yellow);
 schrijfstring (' ' + text); schooneol;
 ganaarxy (80, line - 1);
 setvideo (normal);
end; {guidance}

procedure cleareol (line, col, attrib: integer);
{----------------------------------------------}
{
PURPOSE: Positions cursor at given location and clears line from cursor onwards
using background color implied by given video attribute.}
begin
 setvideo (attrib);
 ganaarxy (col, line);
 schooneol;
end; {cleareol}

procedure putstring (outstring: stringMaxL; line, col, attrib: integer);
{----------------------------------------------------------------------}
{
PURPOSE: Outputs given string at given location with given video attribute.}
begin
 setvideo (attrib); ganaarxy (col, line); schrijfstring (outstring);
end; {putstring}

(*If empty part of field should be of different color:
procedure putbar (line, col, len, color: integer);
{------------------------------------------------}
{
PURPOSE: Writes an empty bar of given length and color at given place.}
var i: integer;
begin
 tekstbackground (color); ganaarxy (col, line); for i := 1 to len do schrijfteken (' ');
end; {putbar}*)

procedure geefblankostaart (var s: stringMaxL; l: integer);
{---------------------------------------------------------}
{PURPOSE: vul string s - indien mogelijk - aan met spaties tot lengte l.}
var h, i: integer;
begin
 h := length (s); for i := h + 1 to l do s := s + ' ';
end; {geefblankostaart}

procedure putpromptedstring (outstring: stringMaxL; attrib, strlength: integer;
                             descstr: stringMaxL; descline, desccol: integer;
                             newline: boolean);
{-----------------------------------------------------------------------------}
{
PURPOSE: Outputs string with given video attribute with explanation at given location.}
var hulpstring: stringMaxL;
begin
 hulpstring := outstring; geefblankostaart (hulpstring, strlength);
 putstring (descstr, descline, desccol, bold);
 if newline
 then putstring (hulpstring, descline + 1, desccol, attrib)
 else putstring (hulpstring, descline, desccol + length (descstr), attrib);
end; {putpromptedstring}

procedure showstring (instring: stringMaxL; line, col, attrib, strlength: integer);
{---------------------------------------------------------------------------------}
{
PURPOSE: Outputs given string at given location with given video attribute,
padding it with blanks to its maximum length.}
var i, len: integer;
begin
 putstring (instring, line, col, attrib);
 (*If empty part of field should be of different color:
 len := strlength - length (instring);
 putbar (line, col + length (instring), len, cyan);*)
 for i := length (instring) + 1 to strlength do putstring (' ', line, col + i - 1, attrib);
end; {showstring}

procedure putcenteredstring (outstring: stringMaxL; line, attrib: integer);
{-------------------------------------------------------------------------}
{
PURPOSE: Centers given string at given line with given video attribute.}
begin
 cleareol (line, 1, attrib);
 putstring (outstring, line, 40 - length (outstring) div 2, attrib);
end; {putcenteredstring}

procedure putprompt (outstring: stringMaxL; line, col: integer);
{--------------------------------------------------------------}
{
PURPOSE: Places a prompt at given location after erasing in black the prompt line.
Remark (NB): bold reverse}
begin
 ganaarxy (col, line); tekstbackground (black); putstring (outstring, line, col, bold + inverse);
end; {putprompt}

procedure puterror (outstring: stringMaxL; line, col: integer);
{-------------------------------------------------------------}
{
PURPOSE: Outputs error message at given location and waits for user to strike
any key.
Remark (NB): bold reverse blinking}
var anychar: char;
begin
 putstring (outstring, line, col, inverse + bold + blinking); anychar := readkey;
end; {puterror}

procedure writeinteger (r: integer; f: integer; fgcolor, bgcolor: integer);
{-------------------------------------------------------------------------}
{PURPOSE: Is essentially Write (r:f) with on-the-spot color settings;
operates in text and graphic modes}
var s: StringMinL;
begin
 tekstcolor (fgcolor); tekstbackground (bgcolor);
 str (r:f, s);
 schrijfstring (s);
end; {writeinteger}

procedure writereal (r: real; f, g: integer; fgcolor, bgcolor: integer);
{----------------------------------------------------------------------}
{PURPOSE: Is essentially Write (r:f:g) with on-the-spot color settings;
operates in text and graphic modes}
var s: StringMinL;
begin
 tekstcolor (fgcolor); tekstbackground (bgcolor);
 str (r:f:g, s);
 schrijfstring (s);
end; {writereal}

procedure writestring (s: string; fgcolor, bgcolor: integer);
{-----------------------------------------------------------}
{PURPOSE: Is essentially Write (s) with on-the-spot color settings;
operates in text and graphic modes}
begin
 tekstcolor (fgcolor); tekstbackground (bgcolor);
 schrijfstring (s);
end; {writestring}

begin
 (*write ('KSPUTS   v1.02-1996 ');*)
 (*write ('KSPUTS   v1.03-2000 ');*) (*2.00 identical to 1.03*)
 (*write ('KSPUTS   v2.00-2001 ');*)
 (*write ('KSPUTS   v2.01-2002 ');*)
 write ('KSPUTS   v2.02-2003 ');
end.
